alias g=git
alias branchgit="g log --graph --abbrev-commit --decorate --date=relative --format=format:'%C(bold blue)%h%C(reset) - %C(bold green)(%ar)%C(reset) %C(white)%s%C(reset) %C(dim white)- %an%C(reset)%C(bold yellow)%d%C(reset)' --all"
alias branchgitdetail="g log --graph --abbrev-commit --decorate --format=format:'%C(bold blue)%h%C(reset) - %C(bold cyan)%aD%C(reset) %C(bold green)(%ar)%C(reset)%C(bold yellow)%d%C(reset)%n''          %C(white)%s%C(reset) %C(dim white)- %an%C(reset)' --all"
alias countcommits='g shortlog -s -n --all'
alias unadd='g reset HEAD'
alias commit='g commit -m'
alias recommit='g commit --amend -m'
alias status='g status'
alias pull='g pull'
alias clone='g clone'
alias gclean='g clean -x'

add()
{
    g diff $1
    g add $1
}

push()
{
    if [ "$1" == "" ]; then
        g push origin master
    else
        g push origin $@
    fi
}

gstats()
{
    git log --format='%aN' | sort -u | while read name; do echo -en "$name      \t"; git log --author="$name" --pretty=tformat: --numstat | awk '{ add += $1; subs += $2; loc += $1 - $2 } END { printf "added lines: %s\tremoved lines: %s\ttotal lines: %s\n", add, subs, loc }' -; done
}

submission()
{
    git tag -f $1 -m "$2"
    git push --tags --force origin master
    git push --force origin master
    branchgit
}

mkpatch()
{
    if [ "$1" == "" ]; then
        f="patch"
    else
        f=$1
    fi
    g diff HEAD^ > $f
}

mkbasics()
{
    echo "* manuel_d" > AUTHORS
    echo "Everything is yet to be done." > TODO
    echo "Hello I am the README." > README
    mkdir src
    mkdir tests
    touch Makefile
    touch .gitignore
}

finalcheck()
{
    make check
    cat TODO
    cat README
    # TODO: Add the moulinette check
}
